package com.trackstudio.soap.example;

import gran.trackstudio.DevPack;
import com.trackstudio.soap.client.TaskBean;
import com.trackstudio.soap.client.UdfValueBean;
import com.trackstudio.soap.client.UdfBean;
import com.trackstudio.soap.client.UdflistBean;
import com.trackstudio.soap.client.MessageBean;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;


public class SoapExample {
    DateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

    int String = 0;
    int FLOAT = 1;
    int DATE = 2;
    int LIST = 3;
    int MULTILIST = 6;
    int TASK = 7;
    int USER = 8;
    int INTEGER = 4;
    int MEMO = 5;
    int URL = 9;



    DevPack dp;
    String sessionId;
    TaskBean tb;


    void printStandardTaskFields() throws Exception {
        System.out.println("Task Id: " + tb.getId());
        System.out.println("Task Name: " + tb.getName());
        System.out.println("Task Short Name: " + tb.getShortname());
        System.out.println("Task Number: " + tb.getNumber());
        if (tb.getBudget() != null)
            System.out.println("Task Budget: " + tb.getBudget());
        if (tb.getAbudget() != null)
            System.out.println("Task Actual Budget: " + tb.getAbudget());
        if (tb.getSubmitdate() != -1)
            System.out.println("Task Submit Date: " + df.format(new Date(tb.getSubmitdate())));
        if (tb.getUpdatedate() != -1)
            System.out.println("Task Update Date: " + df.format(new Date(tb.getUpdatedate())));
        if (tb.getDeadline() != -1)
            System.out.println("Task Deadline: " + df.format(new Date(tb.getDeadline())));
        if (tb.getClosedate() != -1)
            System.out.println("Task Close Date: " + df.format(new Date(tb.getClosedate())));
        if (tb.getCategoryId() != null)
            System.out.println("Task Category: " + dp.getFindService().findCategoryById(sessionId, tb.getCategoryId()).getName());
        if (tb.getStatusId() != null)
            System.out.println("Task Status: " + dp.getFindService().findStatusById(sessionId, tb.getStatusId()).getName());
        if (tb.getResolutionId() != null)
            System.out.println("Task Resolution: " + dp.getFindService().findResolutionById(sessionId, tb.getResolutionId()).getName());
        if (tb.getPriorityId() != null)
            System.out.println("Task Priority: " + dp.getFindService().findPriorityById(sessionId, tb.getPriorityId()).getName());
        if (tb.getSubmitterId() != null)
            System.out.println("Task Submitter: " + dp.getFindService().findUserById(sessionId, tb.getSubmitterId()).getName());
        if (tb.getHandlerUserId() != null)
            System.out.println("Task Handler: " + dp.getFindService().findUserById(sessionId, tb.getHandlerUserId()).getName());
    }

    void printCustomFields() throws Exception {
        UdfValueBean[] udfValues = dp.getUdfService().getUdfValues(sessionId, tb.getId());
        for (int i = 0; i < udfValues.length; i++) {
            if (udfValues[i] != null && udfValues[i].getUdfId() != null) {
                UdfValueBean uvb = udfValues[i];
                UdfBean ub = dp.getFindService().findUDFById(sessionId, uvb.getUdfId());
                int currentUdfType = ub.getType().intValue();
                String udfValue = null;
                String[] udflistIds = uvb.getUdflistId();
                if (ub.getScriptId() != null && ub.getScriptId().length()!=0) {
                    udfValue = dp.getUdfService().getTaskUDFValue(sessionId, tb.getId(), ub.getCaption());
                    System.out.println(ub.getCaption() + ": " + udfValue);
                } else if (!uvb.isEmpty()) {
                    if (currentUdfType == String || currentUdfType == MEMO || currentUdfType == URL)
                        udfValue = uvb.getStr();
                    if (currentUdfType == DATE)
                        udfValue = df.format(new Date(uvb.getDat()));
                    if (currentUdfType == LIST)
                        udfValue = uvb.getUdflistId()[0];
                    if (currentUdfType == FLOAT)
                        udfValue = uvb.getNum() + "";
                    if (currentUdfType == INTEGER)
                        udfValue = uvb.getNum() + "";
                    if (currentUdfType == URL) {
                        String val;
                        val = udfValue;
                        String urlVal = "";
                        String description = "";
                        if (val != null) {
                            int j = val.indexOf("\n");
                            if (j > 1 && j < val.length() - 1) {
                                urlVal = val.substring(0, j);
                                description = val.substring(j);
                            } else if (j == 0) {
                                urlVal = "";
                                description = val;
                            } else
                                urlVal = val;
                        }
                        udfValue = urlVal;
                    }
                    if (currentUdfType == MEMO)
                        udfValue = udfValue.toString();
                    if (currentUdfType == LIST) {
                        UdflistBean[] udflistArray = dp.getUdfService().getUdflist(sessionId, ub.getUdfId());
                        for (int j = 0; j < udflistArray.length; j++)
                            if (udflistArray[j].getId().equals(udfValue))
                                udfValue = udflistArray[j].getVal();
                    }
                    if (currentUdfType == MULTILIST) {
                        UdflistBean[] udflistArray = dp.getUdfService().getUdflist(sessionId, ub.getUdfId());
                        for (int j = 0; j < udflistArray.length; j++) {
                            for (int k = 0; k < udflistIds.length; k++)
                                if (udflistArray[j].getId().equals(udflistIds[k]))
                                    udfValue += udflistArray[j].getVal() + "|";
                        }
                    }
                    if (currentUdfType == TASK) {
                        String[] sl = uvb.getTaskListId();
                        for (int j = 0; j < sl.length; j++)
                            udfValue += "#" + dp.getFindService().findTaskById(sessionId, sl[j]).getNumber() + "|";
                    }
                    if (currentUdfType == USER) {
                        String[] sl = uvb.getUserListId();
                        for (int j = 0; j < sl.length; j++)
                            udfValue += dp.getFindService().findUserById(sessionId, sl[j]).getName() + "|";
                    }
                    System.out.println(ub.getCaption() + ": " + udfValue);
                }
            }
        }
    }

    void printTaskMessages() throws Exception {
        System.out.println("-----------Messages:--------------");
        MessageBean[] mbeans = dp.getMessageService().getMessageList(sessionId, tb.getId());
        for(int i = 0; i < mbeans.length; i++) {
            MessageBean mb = mbeans[i];
            System.out.println("Submit Date: " + df.format(new Date(mb.getTime())));
            System.out.println("Submitter: " + dp.getFindService().findUserById(sessionId, mb.getSubmitterId()).getName());
            System.out.println("Message Type: " + dp.getFindService().findMstatusById(sessionId, mb.getMstatusId()).getName());
            if(mb.getResolutionId() != null)
                System.out.println("Resolution: " + dp.getFindService().findResolutionById(sessionId, mb.getResolutionId()).getName());
            if(mb.getHandlerUserId() != null)
                System.out.println("Handler: " + dp.getFindService().findUserById(sessionId, mb.getHandlerUserId()).getName());
            System.out.println("Message Description:");
            System.out.println(mb.getDescription());
            System.out.println("-------------------------------");
        }
    }


    public SoapExample(String url, String login, String password, String taskNumber) throws Exception {
        System.out.println("url: " + url);
        System.out.println("login: " + login);
        System.out.println("password: " + password);
        System.out.println("taskNumber: " + taskNumber);
        System.out.println("-----------------------------");
        this.dp = new DevPack(url);
        this.sessionId = dp.getUserService().authenticate(login, password);
        tb = dp.getTaskService().findTaskByNumber(sessionId, taskNumber);

        if (tb == null) {
            System.out.println("Task not found");
            return;
        }

        printStandardTaskFields();

        System.out.println("Task Description:");
        System.out.println(tb.getDescription());

        printCustomFields();
        printTaskMessages();
    }


    public static void main(String[] args) throws Exception {
        new SoapExample(args[0], args[1], args[2], args[3]);
    }
}
